DialogBoxMorph subclass: #EnchantingUploadDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-Dialogs'!
!EnchantingUploadDialog commentStamp: '<historical>' prior: 0!
This dialog is designed to allow you to show the progress of what happens when someone hits the green flat in Enchanting.  Specifically, it should show that the code is being exported, compiled, uploaded, and run, and indicates if any errors occur.!


!EnchantingUploadDialog methodsFor: 'as yet unclassified' stamp: 'CWB 10/28/2010 20:39'!
activity: currentAction

	"self message: currentAction."

	done ifTrue: [^nil].

	self addMessageLine: 
		(StringMorph 
			contents: currentAction localized
			font: (ScratchFrameMorph getFont: #DialogBoxMessage)).
	self centerOnScreen.
	

	
	
! !

!EnchantingUploadDialog methodsFor: 'as yet unclassified' stamp: 'CWB 10/28/2010 21:05'!
afterSilenceOf: milliseconds fail: failureMessage
"If the dialog does not hear back from the back end during this time interval, it displays 
the specified error message.  Note that it only check this at the start.  In the rare event
that the back end responds at all but does not respond to close the dialog, the user will
have to hit the 'cancel' button."

[ 
	Delay waitMSecs: milliseconds.  
	messageLineMorphs submorphs size = 0 ifTrue: [ self error: failureMessage ].		
] forkAt: Processor systemBackgroundPriority! !

!EnchantingUploadDialog methodsFor: 'as yet unclassified' stamp: 'CWB 10/28/2010 20:39'!
error: error

	"Adds an error message to the dialog box"

	| s |

	"To Do: each sentance of the error message should
	be translated (if possible) and displayed independantly"

	done ifTrue: [^nil].

	s _ StringMorph 
		contents: error localized
		font: (ScratchFrameMorph getFont: #DialogBoxMessage).
	s color: Color red.
	self addMessageLine: s. 
	self withButtonsForYes: false 
		no: false
		okay: true 
		cancel: false.
	self centerOnScreen.
	

	
	
! !

!EnchantingUploadDialog methodsFor: 'as yet unclassified' stamp: 'CWB 10/23/2010 17:18'!
initialize
	"Sets up the upload dialog box"

	super initialize.
	self title: 'Uploading Program';
		withButtonsForYes: false no: false okay: false cancel: true;
		message: ''.! !
